{
   FedU.fth
   Forth Editor
   uses AutoW.fth
   12.12.23 Christof Eberspaecher
   Teraterm: activate Xon/Xoff
   Windows: Device Manager Com Buffer Size 64bytes, Xon/Xoff
}

!polls \ clear multitasking
%red %pen
IFDEF *Fed*
   singletask
   $fc780023 $7b cog! \ undo patch for LEN$
    fedOrg org
    fedLutPC lutPC !
    fedLutOrg lutOrg !
    FORGET *Fed* }

pub *Fed*    PRINT" FedU" ;

0 bytes fedOrg
lutPC @ := fedLutPC
lutOrg @ := fedLutOrg
%plain

7 cogstop \ no VGA

\ text starts from textbuf $3_3600

$3_3600 value fedBuf$
100 value lWidth#
\ 48 value fedHeight#
4 value fedStartLine# \ top of screen used
65 value fedHeight#
1 value marginsFlag#
4 longs holdBuf
0 value setHold#
0 value iHold#
0 value startList#
0 value lastLine#
0 value actLine#
0 value maxLines#
0 value actCol#
lWidth# 1+ bytes actLine$ 0 actLine$ c!
IFNDEF fedFile$
   32 bytes fedFile$ }
32 bytes writeFile$



long bufFullFlag
bufFullFlag ~
long bufFullMax
bufFullMax ~

: xonXoff \ check filling of serial buffer and emit xon xoff
   32 cog@ 31 cog@ > if
      $300   32 cog@ 31 cog@ - -
   else
      31 cog@ 32 cog@ -
   then
   dup 50 >   bufFullFlag @ 0= and if
      bufFullFlag ~~ 19 emit then
   dup 10 < bufFullFlag @ and if
      bufFullFlag ~ 17 emit then

   bufFullMax @ maxs bufFullMax !
   \ %savePos
   \ 80 2 %XY %yellow %pen . %plain
   \ %restorePos
;


pub Glossary_Library ; \ { ################################################################

33 bytes defName$   0 defName$ !
32 bytes upWord$
0 value defType#

$0D0A3A20 := colDef
$0A505542 := PUBDef
$0A707562 := pubDef
$0A505245 := PREDef
$0A707265 := preDef

: getNextName {: , c# c4# i# -- found } \ get defName from file
   0 to_c4#
   begin
      fget to_c#
      c4# 8 << c# + to_c4#
   c# 0 =   c4# colDef = or   c4# PUBDef = or   c4# pubDef = or
   c4# PREDef = or   c4# preDef = or until
   c# 0 = if 0 to defType# 0 cEndloc exit then
   c4# colDef = if _fread @ 2 -
   else _fread @ 3 - fget drop then
   0 to_i#
   c4# to defType#
   begin
      fget to_c#
      c# 32 > if
         c# defName$ i# + c!
         1 +to_i#
      then
   c# 33 < until
   0 defName$ i# + c!
   ( _fread )
; forgetLocals


: listGlossary \ do colored listing of open file
   begin
   getNextName dup while
      defType# PUBDef = defType# pubDef = or if crlf %red %pen then
      \ .
      drop
      defName$ print$ ."   " %plain
   repeat
   drop
   fclose
;

: listGlos \ list glos.fth
   " glos.fth" fopen$ 0exit
   listGlossary
;

: listAuto \ list auto.f
   " auto.f" fopen$ 0exit
   listGlossary
;

: prtFileLine \ print one line of an open file
   begin
      fget dup emit
   10 = until
;

: prtGlos {: str$ , f# -- } \ usage " PRINT$" prtGlos print gloassary entry
   ." ..searching"
   " glos.fth" fopen$ 0= if cEndloc exit then
   str$ upWord$ $!
   upWord$ upper$
   begin
      getNextName to_f#
      f# if
         defName$ str$ $=   defName$ upWord$ $= or if
            \ crlf
            f# _fread !
            cr %erline
            prtFileLine
            -1 to_f#
         then
      then
   f# 1 < until
   fclose
   f# -1 <> if
      cr %erline
      ." ...not found! "
   then
; forgetLocals

: lookupGlos {: , i# pos# } \ asks for topic of glos.fth
   " glos.fth" fopen$ 0= if cEndloc exit then
   key drop
   0 to_i#
   begin
   getNextName while
      defType# PUBDef = defType# PUBDef = or if
         i# 2 // 0= if crlf then
         %green %pen i# 48 + emit ."  "
         %plain defName$ print$
         34 defName$ len$ - spaces
         1 +to_i#
      then
   repeat
   crlf ." Sign to Choose? " wkey
   dup emit
   47 - to_i#
   0 _fread !
   crlf
   begin
   getNextName to_pos#
   pos# while
      defType# PUBDef = defType# PUBDef = or if -1 +to_i# then
      i# 0= if
         begin
            pos# sdc@ dup emit
            1 +to_pos#
         10 = until
      then
   repeat

   fclose
; forgetLocals

\ } Glossary_Library

pub Proposal_Library ; \ { #########################################

1 value propFlag#
2 value minDictLen#
long propNFA \ NFA of the selected word.
long wordsNr \ number found of matching words.
long propNr \ number choosen
long matchLen


code newLEN$ ( str$ -- length ) ' \ original fails when interrupted
   mov r0,a
   mov a,#0
   .l1 rdbyte r1,r0 wz
      if_z ret
      add r0,#1
      add a,#1
   jmp #l1
   jmp #\0 ' \ dummy to get the code for patch
end
\ 0BC22 FD80_0000     jmp #\0 ' \ dummy to get the code for patch
' newLEN$ 2+ $FD80_0000 or $7b cog! \ patch jmp to newLEN$ into original cog routine
\ : LEN$ newLEN$ ;
: newMATCH? ( str words. -- str words. flg )
      -1
      matchLen @ FOR
      ( str words. flg ) 3RD I+ C@ 3RD 1+ I+ C@ = AND NEXT
;


: prtProposal {: str$ , n# len# -- } \ print dict entries
   str$ len$ dup matchLen !
   if
      0 to_n#
      0 to_len# \ total length of printout
      str$ upWord$ $!
      upWord$ upper$
      str$
      @WORDS
      wordsNr ~
      BEGIN
         DUP W@
      len# lWidth# 2 * 20 - <   and WHILE
            ( str NFA ) newMATCH? ( str NFA flag )
            \ 3RD 0= OR ( str NFA flag )
            upWord$ 3RD newMATCH? -rot 2drop OR if
               wordsNr @ propNr @ = if
                  dup propNFA !
               then
               %green %pen n# 48 + emit %plain SPACE
               DUP .NFA
               SPACE SPACE
               1 +to_n#
               wordsNr ++
               DUP c@ $1F and 4 + +to_len#
            THEN
            NFA+
      REPEAT
      len# lWidth# 2 * 20 - => if ."  ..." then
      2DROP
   then
; forgetLocals

\ } Proposal_Library

pub fedPrint_Library ; \ { #########################################

: blueHigh \ structure words.
 " : PUB PRE PRI CODE CREATE$ END IF ELSE THEN EXIT 0EXIT ?EXIT ; ; "
;

: redHigh \ loops
 " BEGIN AGAIN UNTIL WHILE REPEAT FOR NEXT DO ?DO LOOP +LOOP "
;

: defWords$ \ definition words.
 " PUB PRE PRI : CODE CREATE$ LONG LONGS WORD WORDS BYTE BYTES VALUE := "
\  012345678 112345678 212345678 312345678
;

long foundPos

create$ <aLmove lutPC @ 512 + @words CPA W!
code (<aLmove) ( src dest cntLongs --  ) ' \
   getStart
   rep #4,a
      rdlong r0,c
      sub c,#4
      wrlong r0,b
      sub b,#4
   jmp #\@3DROP
   getEnd
end
mov2Lut

: <lmove ( src dest cntLongs -- )
   rot over cells + 4 -
   rot 3RD cells + 4 -
   rot
   <aLmove
;

create$ findBlank lutPC @ 512 + @words CPA W!
code (findBlank) ( pointer dir -- pointer dir ) ' \
   getStart
   .l1 add b,a
      rdbyte r1,b
      cmp r1,#33 wc
   if_nc jmp #l1
   ret
   getEnd
end
mov2Lut

create$ findNonBlank lutPC @ 512 + @words CPA W!
code (findNonBlank) ( pointer dir -- pointer dir ) ' \
   getStart
   .l1 add b,a
      rdbyte r1,b
      cmp r1,#33 wc
   if_c jmp #l1
   ret
   getEnd
end
mov2Lut

create$ aIncluded lutPC @ 512 + @words CPA W!
code (aIncluded) ( word cString dummy -- word cString flag ) ' \
   getStart
   mov a,#100      ' \ clear flag but prepared
   .l2 mov r0,c       ' \ word start
   .l3 rdbyte r2,b wz ' \ cString
       if_z ret       ' \ end of cString reached
      rdbyte r1,r0 wz ' \ word
      if_nz skipf #%111
         cmp r2,#32 wz ' \ must be blank
         if_nz mov a,#0 ' \ clear flag in a
         ret          ' \ end of word reached
      add b,#1
      add r0,#1
      cmp r1,r2 wz   ' \ same char?
      if_z add a,#1
      if_z jmp #l3
      mov a,#0    ' \ search for blank first
      cmp r2,#32 wz ' \ blank?
      if_z mov a,#100
      jmp #l2
   getEnd
end
mov2Lut

: included ( word# cString# -- flag ) \ is word in cString?
   over UPPER$
   0 \ dummyflag
   aIncluded
   ( flag ) 100 > if
      foundPos !
      drop
      1
   else
      2drop
      0
   then
;


lWidth# 1+ bytes prtLine$   0 prtLine$ c!
0 value comFlag# \ flag for comments

: checkComments {: c# i# -- } \ check if c# starts or ends comment
   c# '-' =
   i# 1+ c@ '-' = and
   i# 2 + c@ '-' = and
   i# 3 + c@ 32 = and
   if
      comFlag# 1 or to comFlag#
      %green %pen
   then
   c# '\' =
   i# 1+ c@ 32 = and if
      comFlag# 1 or to comFlag#
      %green %pen
   then
   c# '{' = i# 1+ c@ 32 = and comFlag# 0= and if \
      comFlag# 4 or to comFlag#
      %green %pen
   then
   c# '}' = i# 1+ c@ 32 = and if \
      comFlag# 4 not and to comFlag#
   then
   c# '(' = i# 1+ c@ 32 = and if \
      comFlag# 2 or to comFlag#
      %green %pen
   then
   c# ')' = i# 1+ c@ 32 = and if \
      comFlag# 2 not and to comFlag#
   then
   comFlag# 0 maxs to comFlag#
; forgetLocals

32 bytes upWord$

: checkColors ( word. -- ) \ check words. color
   dup c@ 48 57 within 0= if \ no number search in vocabulary
      dup search 0= if
         dup upWord$ $!
         upWord$ dup upper$ search 0= if
            %yellow %pen
         then
      then
   then
   \ dup UPPER$ search if %plain then
   dup blueHigh included if %cyan %pen then
   redHigh included if %red %pen then
;

: cpyWord {: src# dest# , cnt#  -- } \ copy one word until c < 33
   0 to_cnt#
   begin
   src# c@ dup 32 >   cnt# 31 < and while
      dest# c!
      1 +to_src#  1 +to_dest#   1 +to_cnt#
   repeat
   drop
   0 dest# c!
; forgetLocals


: prtLineHigh {: line$ , i# c# -- } \ print colored line
   line$ to_i#
   begin
      i# c@ to_c#
      c# i# checkComments
      comFlag# 0= c# 32 > and if
         i# prtLine$ cpyWord
         \ prtLine$ WORD$ \ dup print$
         prtLine$ checkColors
         begin
            c# emit
            1 +to_i#
            i# c@ to_c#
         c# 33 < i# line$ - lWidth# => or until
         %plain
      then
      i# line$ - lWidth# < if
         c# emit then

      comFlag# -1 = if
         -1 +to comFlag#
         %plain
      then
      1 +to_i#

   c# 0 = i# line$ - lWidth# => or until
   comFlag# 1 and if
      comFlag# 1 not and to comFlag#
      comFlag# 0 <= if
         %plain
      then
   then
; forgetLocals

" pre loli 10 for i . next comFlag# ( pri ) ; " prtLineHigh

long wordPoint    fedBuf$ wordPoint !
long defPoint     fedBuf$ defPoint !
1 value direction#


: findWord ( -- foundFlag ) \ modifies wordPoint, uses direction#
   wordPoint @
   direction#
   findBlank
   findNonBlank
   dup 0 < if
      findBlank
      drop \ dir
      1+
   else drop \ dir
   then
   dup fedBuf$ dup maxLines# lWidth# * + within if
      wordPoint !
      1
   else
      drop
      0
   then
;

pub fedDef_Library ; \ ###################################

: findDef {: , wFlag# dFlag# -- foundflag } \ find next definition in defPoint
   defPoint @ wordPoint !
   begin
      \ wordPoint @ 10 ctype ." ** "
      0 to_dFlag#
      findWord dup to_wFlag# if
         wordPoint @ prtLine$ cpyWord
         \ prtLine$ print$ ."  -- "
         prtLine$ defWords$ included dup to_dFlag# if
            direction# \ keep
            1 to direction# findWord drop
            to direction# \ restore
         then
      then
   wFlag# 0= dFlag# or until
   dFlag# if
      wordPoint @ defPoint !
      1
   else 0 then
; forgetLocals


15 value wDefChars# \ width of columns for print of defs

: prtNChars$ {: start# , i# c# } \ prints max wDefChars# of a word.
   0 to_i#
   wDefChars# 1- for
      start# i# + c@ to_c#
      c# 32 > if
         c# emit
         1 +to_i#
      else
         32 emit
      then
   next
   32 emit
; forgetLocals

: prtDefLines \ prt all definition lines colored
   crlf
   1 to direction#
   fedBuf$ defPoint !
   begin
   findDef while
      defPoint @ fedBuf$ - lWidth# / lWidth# * fedBuf$ +
      prtLineHigh crlf \ 99 ctype crlf
   repeat
; forgetLocals


: cur2Add ( -- addr ) \ cursor to addresse
   fedBuf$ actLine# lWidth# * + actCol# + ;

33 bytes curWord$   0 curWord$ c!
long curstart
long oldCurstart

: getCurWord \ word under cursor into curWord$ and it's start into curstart
   cur2Add -1 ( findNonBlank ) findBlank drop 1+
   dup curstart !
   fedBuf$ max
   curWord$ cpyWord
;


: searchCurDefLine {: , foundDef# found# -- 1/0 }
   1 to direction#
   fedBuf$ defPoint !
   begin
      findDef dup to_foundDef# if
         defPoint @ prtLine$ cpyWord
         prtLine$ curWord$ $= to_found#
      else 0 to_found# then
   foundDef# 0= found# or until
   found#
; forgetLocals

: prtCurDefLine \ search and print def of current word
   searchCurDefLine  if
      defPoint @ fedBuf$ - lWidth# / lWidth# * fedBuf$ +
      prtLineHigh crlf \ 99 ctype crlf
   else
      ." ... not found "
   then
;

: prtCurDef \ for key
   getCurWord
   curWord$ c@ 0exit
   0 3 %xy %erline
   prtCurDefLine
;

: prtNoAZ ( no -- ) \ print number as AA:
      %green %pen
      dup 26 / 65 + emit
      26 // 65 + emit
      58 emit
      %plain
;

: prtDefs {: , no# } \ print table of defs
   0 3 fedStartLine# + %xy
   %erline
   0 to_no#
   1 to direction#
   fedBuf$ defPoint !
   wDefChars# \ position
   begin
   findDef while
      foundPos @ defWords$ - 4 < if \ PUB.
         crlf %erline drop wDefChars#
         no# prtNoAZ
         drop 999 \ force crlf
         %red %pen
      else
         no# prtNoAZ
         foundPos @ defWords$ - 26 > if %blue %pen
         else
            %plain
         then
      then
      defPoint @ prtNChars$
      wDefChars# + 3 + \ position
      dup lWidth# > if
         crlf %erline
         drop wDefChars# \ reset position
      then
      1 +to_no#
   repeat

   drop
; forgetLocals

\ } } print_Library

pub fedFile_Library ; \ { ##########################################

: fillLine \ fill the actual line in fedBuf$ to lWidth# with BLANKS
   begin
   actCol# lWidth# < while
      32 fedBuf$ actLine# lWidth# * + actCol# + c!
      1 +to actCol#
   repeat
   0 to actCol#
   1 +to actLine#
;

: insBlankLine \ above
   fedBuf$ actLine# lWidth# * +
   dup \ source
   dup lWidth# + \ dest
   maxLines# actLine# - lWidth# * \ cnt
   <cmove
   lWidth# 32 fill
   1 +to maxLines#
;

: deleteLine \ delete actual line sets actLine# and maxLines#
   actLine# 1+ maxLines# < if
      fedBuf$ actLine# lWidth# * +
      dup lWidth# + \ source
      swap
      maxLines# 1- actLine# - lWidth# * \ cnt
      cmove
   then
   -1 +to maxLines#
   \ -1 +to actLine#
   actLine# maxLines# 1- mins to actLine#
;


:  newBlankLine \ under
   bufFullFlag ~~ 19 emit \ xoff
   fedBuf$ actLine# 1+ lWidth# * +
   actLine# 1+ maxLines# < if
      dup \ source
      dup lWidth# + \ dest
      maxLines# actLine# 1+ - lWidth# * \ cnt
      \ <cmove
      4/ <lmove
   then
   lWidth# 32 fill
   1 +to maxLines#
   1 +to actLine#
;
\ <lmove lap newBlankLine lap .lap --- 695,976 cycles= 3,479,880ns @200MHz ok
\ war lap newBlankLine lap .lap --- 2,863,480 cycles= 14,317,400ns @200MHz ok


:  splitLine \ at cursor pos
   fedBuf$ actLine#  lWidth# * + actCol# +
      dup \ source
      dup lWidth# + \ dest
      maxLines# actLine# 1+ - lWidth# * lWidth# + actCol# - \ cnt
      <cmove
   lWidth# 32 fill
   1 +to maxLines#
   1 +to actLine#
;


: readFile {: , inch# , col# line# } \ into fedBuf$ with fixed length lines
   fedFile$ fopen$ 0= if cEndloc exit then
   0 to actCol#
   0 to actLine#
   begin
      fget to_inch#
      inch# 10 = if fillLine then
      inch# 32 127 within if
         inch# fedBuf$ actLine# lWidth# * + actCol# + c!
         1 +to actCol#
         actCol# lWidth# = if
            0 to actCol#
            1 +to actLine#
         then
      then
   inch# 0= until
   fclose
   actLine# to maxLines#
; forgetLocals

: insertFile {: , inch# , col# line# } \ into fedBuf$ with fixed length lines
   " fedBuf.txt" fopen$ 0= if cEndloc exit then
   0 to actCol#
   newBlankLine \ under
   begin
      fget to_inch#
      inch# 10 = if fillLine -1 +to actLine# newBlankLine then
      inch# 32 127 within if
         inch# fedBuf$ actLine# lWidth# * + actCol# + c!
         1 +to actCol#
         actCol# lWidth# = if
            0 to actCol#
            1 +to actLine#
         then
      then
   inch# 0= until
   fclose
   \ actLine# to maxLines#
; forgetLocals

: findEnd ( -- ) \ actCol# to last char of line
   lWidth#
   begin
      1- dup
   fedBuf$ actLine# lWidth# * + + c@ 32 <> until
   1+ lWidth# 1- mins
   0 maxs to actCol#
;

0 value blockMarker# \ line


: exportFile {: , ch# sdP# } \ from fedBuf$ with variable length lines
   blockMarker# actLine# < if \ swap
      blockMarker# actLine# to blockMarker# to actLine#
   then
   RW " fedBuf.txt" fopen$ 0= if cEndloc exit then
   %yellow %pen %erline
   ." ....saving Block.... "
   @FILE 0= IF
      RW 1 MB MAKE file$ FOPEN$ 0EXIT
   THEN
   0 to_sdP#
   begin
   actLine# blockMarker# <= while
      findEnd
      actCol# 0 > if
         actCol# for
            fedBuf$ actLine# lWidth# * + i + c@ \ source
            sdP# sdc!
            1 +to_sdP#
         next
      then
      13 sdP# sdc!
      1 +to_sdP#
      10 sdP# sdc!
      1 +to_sdP#
      deleteLine
      -1 +to blockMarker#
   repeat
   0 sdP# sdc!
   fclose
   ." Done" %plain crlf
; forgetLocals


: copyToFile {: , ch# sdP# } \ from fedBuf$ with variable length lines
   blockMarker# actLine# < if \ swap
      blockMarker# actLine# to blockMarker# to actLine#
   then
   RW " fedBuf.txt" fopen$ 0= if cEndloc exit then
   %yellow %pen %erline
   ." ....saving Block.... "
   @FILE 0= IF
      RW 1 MB MAKE file$ FOPEN$ 0EXIT
   THEN
   0 to_sdP#
   begin
   actLine# blockMarker# <= while
      findEnd \ sets actCol#
      actCol# 0 > if
         actCol# for
            fedBuf$ actLine# lWidth# * + i + c@ \ source
            sdP# sdc!
            1 +to_sdP#
         next
      then
      13 sdP# sdc!
      1 +to_sdP#
      10 sdP# sdc!
      1 +to_sdP#
      1 +to actLine#
   repeat
   0 sdP# sdc!
   fclose
   ." Done" %plain crlf
; forgetLocals


: writeFile {: , ch# sdP# li# co# } \ from fedBuf$ with variable length lines
   actCol# to_co#
   actLine# to_li#
   RW writeFile$ fopen$ 0= if cEndloc exit then
   %yellow %pen %erline
   ." ....saving.... "
   @FILE 0= IF
      RW 1 MB MAKE file$ FOPEN$ 0= if cEndloc exit then
   THEN
   0 to actLine#
   0 to_sdP#
   begin
   actLine# maxLines# < while
      findEnd
      actCol# 0 > if
         actCol# for
            fedBuf$ actLine# lWidth# * + i + c@ \ source
            sdP# sdc!
            1 +to_sdP#
         next
      then
      13 sdP# sdc!
      1 +to_sdP#
      10 sdP# sdc!
      1 +to_sdP#
      1 +to actLine#
   repeat
   0 sdP# sdc!
   fclose
   ." Done" %plain crlf
   co# to actCol#
   li# to actLine#
; forgetLocals

: wrMen ( ) \ write text as blockfile men.blk
   RW " men.blk" fopen$ 0= if cEndloc exit then
   %yellow %pen %erline
   ." ....saving as men.blk .... "
   @FILE 0= IF
      RW 1 MB MAKE file$ FOPEN$ 0EXIT
   THEN

   maxLines# for
      lWidth# 4/ for
         j lWidth# * i cells +
         dup fedBuf$ + @
         swap sd!
      next
   next
   0 maxLines# lWidth# * sd!
   ." Done"
   %plain
;


pub fedEdit_Library ; \ { ############################################
long listFiFlag
long updateLiFlag

: listLine ( line -- ) \ number relative to startList#
   %erline
   startList# +
   marginsFlag# if
      dup 5 .decs
      dup blockMarker# = if
         %magenta %pen ." M"
      else ."  " then
   then
   lWidth# * fedBuf$ + prtLineHigh
   marginsFlag# if ." |" then
   crlf
;

: keyPending ( -- 0/1 ) \ true if key in buffer
   31 cog@ 32 cog@ <>
;

: prtHeader \
   0 1 fedStartLine# + %xy
   %erline %magenta %pen fedFile$ print$ \ actLine# . actCol# .
   ."  Free: "
   userdata fedBuf$ maxLines# lWidth# * + - lWidth# / 4 .decs
   ."  Top Z=Centr A,F=Def S,D=Wrd " ." JmpMark K=Mark Look Next Go Block/Hlp"
   crlf %erline
   ." Quit X=cut V=ins Y=split R=Nrs PrtDef O=JmpDef " ." U=save W=Glosa E=Propos"
;

: doListFile {: , i# } \
   listFiFlag dup w@ swap 2 + w! \ mark done
   prtHeader
   %plain
   0 3 fedStartLine# + %xy
   0 to_i#
   0 to comFlag#
   begin
   startList# i# + maxLines# <   i# fedHeight# < and while
      i# listLine
      1 +to_i#
   repeat
   begin
   i# fedHeight# < while
      %erline crlf
      1 +to_i#
   repeat
   0 to comFlag#
; forgetLocals

: listFile \ mark to be done
   listFiFlag w++
;

: doLineUpdate
   \ 0 1 %xy %erline %plain fedFile$ print$ ."  " actLine# . actCol# .
   updateLiFlag dup w@ swap 2 + w! \ mark done
   0 actLine# startList# - 3 + fedStartLine# + %xy
   actLine# startList# - listLine
;

: lineUpdate \ mark to be updated
   updateLiFlag w++
;

0 value key#

: insChar ( -- ) \ insert key#
   fedBuf$ actLine# lWidth# * + actCol# +
   actCol# 1+ lWidth# < if
      dup \ source
      dup 1+ \ dest
      lWidth# actCol# - 1- \ cnt
      <cmove
   then
   key# swap c!
   actCol# 1+ lWidth# 1- mins to actCol#
;

: bsChar ( -- ) \ backspace
   actCol# 0exit
   fedBuf$ actLine# lWidth# * + actCol# +
   \ source
   dup 1- \ dest
   lWidth# actCol# - \ cnt
   cmove
   32 fedBuf$ actLine# 1+ lWidth# * + 1- c!
   actCol# 1- 0 maxs to actCol#
;

: delChar ( -- ) \ delete char
   fedBuf$ actLine# lWidth# * + actCol# + 1+ \ source
   dup 1- \ dest
   lWidth# actCol# - \ cnt
   cmove
   32 fedBuf$ actLine# 1+ lWidth# * + 1- c!
   \ actCol# 0 maxs to actCol#
;


: addrRange ( addr -- addr ) \ limit to text buffer
   fedBuf$ maxs
   fedBuf$ maxLines# lWidth# * + 1- mins
;

: centerAddr ( addr ) \ if near borders center on screen
   addrRange
   fedBuf$ - dup lWidth# / to actLine#
   lWidth# // to actCol#
   actLine# startList# 3 + startList# fedHeight# + 3 - within not if
      actLine# fedHeight# 2 / - 0 maxs to startList#
      listFile
   then
;

: centerAddr1 ( addr ) \ center line on screen
   addrRange
   fedBuf$ - dup lWidth# / to actLine#
   lWidth# // to actCol#
      actLine# fedHeight# 2 / - 0 maxs to startList#
      listFile
;

: add2Cur ( addr -- ) \ set cursor to adress
   fedBuf$ - dup lWidth# / to actLine#
   lWidth# // to actCol#
;


: topAddr ( addr ) \ print on top of screen
   addrRange
   fedBuf$ - dup lWidth# / to actLine#
   lWidth# // to actCol#
   actLine# 3 - 0 maxs to startList#
   listFile
;


: getDefPos \ display table for selection of definitions, ask, jump
   1 to direction#
   prtDefs
   crlf
   %erline
   ." Line? (ESC for back)" wkey
   dup 27 = if
      drop listFile exit
   then
   dup emit
   ."  Tab? " wkey dup emit
   \ 48 - swap 48 - lWidth# wDefChars# 3 + / * + \ number
   65 - swap 65 - 26 * +
   dup ."  " .
   fedBuf$ defPoint !
   ( number ) 1+ for
      findDef drop
   next
   defPoint @ topAddr
;

256 bytes cutBuf$

: cutLine \ delete actual line into cutBuf$
   fedBuf$ actLine# lWidth# * + \ source
   cutBuf$ \ dest
   lWidth# \ cnt
   cmove \ copy
   actLine# 1+ maxLines# < if
      fedBuf$ actLine# lWidth# * +
      dup lWidth# + \ source
      swap
      maxLines# 1- actLine# - lWidth# * \ cnt
      cmove
   then
   -1 +to maxLines#
   \ -1 +to actLine#
   actLine# maxLines# 1- mins to actLine#
;

: insCutLine \ insert a line from cutBuf$
   insBlankLine
   cutBuf$ \ source
   fedBuf$ actLine# lWidth# * + \ dest
   lWidth# \ cnt
   cmove
;

: jumpHold \ jump to next marker round robin
   holdBuf iHold# cells + @
   iHold# 1+ 3 and to iHold#
   centerAddr1
;

: setHold \ set marker and also blockMarker#
   cur2Add holdBuf setHold# cells + !
   setHold# 1+ 3 and to setHold#
   actLine# to blockMarker#
;


lWidth# bytes searchStr$   0 searchStr$ c!
0 value saveAdd#

: searchNext {: , i# flag# } \ down from cursor
   cur2Add to_i#
   begin
      i# 1 findNonBlank drop to_i#
      i# prtLine$ cpyWord
      prtLine$ searchStr$ $= to_flag#
   i# fedBuf$ maxLines# lWidth# * + >
   flag# or until
   \ i# fedBuf$ maxLines# lWidth# * + < if
   flag# if
      i# centerAddr1
      1
   else 0
   then
; forgetLocals

: getString {: str$ , c# -- }
   begin
   wkey dup emit to_c#
   c# 13 <> while
      c# str$ !
      1 +to_str$
   repeat
   0 str$ !
   wkey \ lf
; forgetLocals


: searchString \ get string and start search from top
   0 3 fedStartLine# + %xy %erline
   ." Searchstring? " searchStr$ getString
   cur2Add to saveAdd#
   0 to actLine#   0 to actCol#
   searchNext 0= if \ go back
      saveAdd# centerAddr1
   then
;


: jumpDef \ for key jump to def of word under cursor
   getCurWord
   searchCurDefLine if
      setHold
      defPoint @ topAddr
   then
;

: prtCurGlos \ print glossary entry of word. under cursor
   getCurWord
   curWord$ len$ minDictLen# 32 within 0exit
   0 4 %xy %erline
   0 3 %xy %erline
   curWord$ prtGlos
;

0 value propOldPos#
long oldCurLen

: prtCurProposal \ print matching glossaries entry of word. under cursor
   actLine# actCol# W>L
   dup propOldPos# = if drop exit then
   to propOldPos#
   cur2Add 1- c@ 32 = ?exit
   getCurWord
   curstart @ oldCurstart @ = curWord$ len$ oldCurLen @  = and ?exit
   curWord$ len$ oldCurLen !
   curstart @ oldCurstart !
   curWord$ len$ minDictLen# 32 within 0exit
   0 4 %xy %erline
   0 3 %xy %erline
   curWord$ prtProposal
;

: putPropWord \ put selcted Word. at cursor
   propNFA @ C@++ $1F AND
   for
      c@++ to key#
      insChar
   next
   drop
;

: propHandle \ handle proposal choice, insert
   0 3 fedStartLine# + %xy %erline %yellow %pen
   ."  Proposal Choice? ^E=Off Esc=End " wkey to key#
   %plain
   key# ^E = if 0 to propFlag# listFile exit then
   key# 27 = if listFile exit then
   key# 48 - 0 wordsNr @ within 0= if listFile exit then
   key# 48 - propNr !
   curWord$ prtProposal \ update propNFA
   cur2Add -1 findBlank drop 1+ \ cur at begin of word
   add2Cur
   curWord$ len$ for delChar next \ del old word
   putPropWord
   listFile
;

: ESC5B \ cursor movement
   SWITCH --- ANSI KEY SEQUENCES USE $1B $5B ?? ??
 UP_     'A' CASE
            actLine# 1- 0 maxs to actLine# cur2Add centerAddr BREAK
 DN_     'B' CASE
            actLine# 1+
            maxLines# 1- mins to actLine# cur2Add centerAddr BREAK
 ->_     'C' CASE
            actCol# 1+ lWidth# 1- mins to actCol# BREAK
 <-_     'D' CASE
            actCol# 1- 0 maxs to actCol# BREAK
 HOME_   '1' CASE WKEY DROP 0 to actCol# BREAK
 END_    '4' CASE WKEY DROP findEnd BREAK
 PGUP_   '5' CASE WKEY DROP
            startList# fedHeight# 5 * 6 / - 0 maxs
            dup to startList#
            3 + maxLines# 1- mins to actLine#
            listFile BREAK
 PGDOWN_ '6' CASE WKEY DROP
            startList# fedHeight# 5 * 6 / +
            maxLines# fedHeight# 5 * 6 / - mins
            0 maxs
            dup to startList#
            3 + maxLines# 1- mins to actLine#
            listFile BREAK
;

pri SEDESC
   a>A SWITCH --- ESC <KEY> COMMANDS
    ANSI_   $5B CASE WKEY ESC5B BREAK
    \ FNC_    $4F CASE WKEY FNCKEY BREAK
    \ DEL_    $7F CASE tDEL BREAK
;

: blockHeader \ print header with hints
   0 1 fedStartLine# + %xy
   %erline %cyan %pen fedFile$ print$ \ actLine# . actCol# .
   ."  Free: "
   userdata fedBuf$ maxLines# lWidth# * + - lWidth# / 4 .decs
   ."  h=Help i=insertFile  c= copyToFile x=cutToFile"
   crlf %erline

   %plain
;

: blockKey
   blockHeader
   wkey SWITCH
   help_     'h' case
      " fed.hlp" fopen$ 0exit
      page (cat)
      crlf ." Key?" wkey key drop listFile
      cur2Add centerAddr1 BREAK
   insBlock_ 'i' case
      insertFile cur2Add centerAddr1 BREAK
   expBlock_ 'x' case
      exportFile cur2Add centerAddr1 BREAK
   copToBl_  'c' case
      copyToFile cur2Add centerAddr1 BREAK
   listFile \ default
;

: fedKey
   key# switch
   normal_  32 126 <case>
      insChar lineUpdate break
   BS_      8 case
      bsChar lineUpdate break
   DEL_     127 case
      delChar lineUpdate break
   CR_     13 case wkey drop
      newBlankLine listFile
      0 to actCol# BREAK
   TAB_    9 case 32 to key# insChar insChar insChar
      lineUpdate break
   ESC_     $1B CASE WKEY SEDESC BREAK
   TOP_     ^T CASE cur2Add topAddr BREAK
   ZENTER_  ^Z CASE cur2Add centerAddr1 BREAK
   >word_   ^D CASE
      cur2Add wordPoint !
      1 to direction#
      findWord drop wordPoint @ centerAddr BREAK
   <word_   ^S CASE
      cur2Add wordPoint !
      -1 to direction#
      findWord drop wordPoint @ centerAddr BREAK
   >def_   ^F CASE
      cur2Add defPoint !
      1 to direction#
      findDef drop defPoint @ centerAddr BREAK
   <def_   ^A CASE
      cur2Add wordPoint !
      -1 to direction#
      findWord drop
      wordPoint @
      defPoint !
      findDef drop defPoint @ centerAddr BREAK
   goDef_   ^G CASE
      getDefPos BREAK
   blockKey_  ^B CASE
      blockKey BREAK
   cutLine_ ^X CASE
      cutLine listFile BREAK
   insCut_  ^V CASE
      insCutLine listFile BREAK
   togMarg_ 18 CASE \ R
      marginsFlag# not 1 and to marginsFlag# listFile BREAK
   look_    12 CASE \ L
      searchString BREAK
   lookNext_ 14 CASE \ N
      searchNext drop BREAK
   setHold_  11 CASE \ K
      setHold listFile BREAK
   jumpHold_ 10 CASE \ J
      jumpHold BREAK
   jumpDef_  15 CASE \ O hold and jump to definition
      jumpDef BREAK
   prtCurDef_ 16 CASE \ P
      prtCurDef BREAK
   updFile_  21 CASE \ U
      0 fedHeight# 3 + fedStartLine# + %xy
      writeFile  BREAK
   prtGlos_  23 CASE \ W
      prtCurGlos BREAK
   splitLine_ 25 CASE \ Y
      splitLine listFile BREAK
   togPropos_ 5 CASE \ E
      propFlag# 0= if 1 to propFlag#  else propHandle then BREAK
;



\ } fedEdit_Library

: testEd " test1.fth" fedFile$ $! ;
\ " sis65.f" fedFile$ $!
\ " auto.f" fedFile$ $!
: fedEd " fed.fth" fedFile$ $! ;   \ fedEd
\ : fredEd " fred.fth" fedFile$ $! ;
\ : helpEd " help.fth" fedFile$ $! ; helpEd

IFNDEF reload
: reload \ load fedFile$
   !POLLS
   fedFile$ fopen$ if
      @file floads
   then
;
}

: fed \ program entry
   0 1 %xy %erline
   0 2 %xy %erline
   0 3 %xy %erline
   0 4 %xy %erline
   1 to maxLines#
   readFile
   key drop
   fedFile$ writeFile$ $!
   0 to actCol#
   0 to actLine#
   0 to startList#
   listFile
   begin
      xonXoff
      keyPending 0=   updateLiFlag @ L>W <> and if doLineUpdate then
      keyPending 0=   listFiFlag @ L>W <> and if doListFile then
      keyPending 0=   propFlag# and if prtCurProposal then

      6 marginsFlag# * 1+ actCol# +   actLine# startList# - 3 + fedStartLine# + %xy
      wkey to key#
      fedKey
   key# ^Q = until
   0 fedHeight# 3 + fedStartLine# + %xy
   %erline
   ." Save File: Y   Execute: X / other=no " wkey to key#
   key# 'Y' = if
      writeFile
   then
   key# 'X' = if
      writeFile
      reload
   then
;

: .key
   key drop
   begin
      wkey dup .emit dup .byte ."  "
   ^Q = until
;




IFDEF wttPoll
   ' wttPoll +poll }
